# class LLVM::ABI::X86_64

- LLVM::ABI::X86_64
- LLVM::ABI
- Reference
- Object

##
Overview

Based on https://github.com/rust-lang/rust/blob/29ac04402d53d358a1f6200bea45a301ff05b2d1/src/librustc_trans/trans/cabi_x86_64.rs See also, section 3.2.3 of the System V Application Binary Interface AMD64 Architecture Processor Supplement

DEPRECATED This API is now internal to the compiler and no longer updated publicly.

##
Defined in:

llvm/abi/x86_64.cr

##
Constant Summary

MAX_INT_REGS = `6`
MAX_SSE_REGS = `8`

##
Instance Method Summary

- #abi_info(atys : Array(Type), rty : Type, ret_def : Bool, context : Context) : LLVM::ABI::FunctionType
- #align(type : Type) : Int32
- #all_mem(reg_classes)
- #classify(ty, cls, ix, off)
- #classify(type)
- #classify_struct(tys, cls, i, off, packed) : Nil
- #fixup(ty, cls) : Nil
- #has_misaligned_fields?(type : Type, offset : Int = 0) : Bool
- #int_register?(type) : Bool
- #llreg(context, reg_classes) : LLVM::Type
- #llvec_len(reg_classes) : Int32
- #pass_by_val?(cls) : Bool
- #register?(type) : Bool
- #size(type : Type) : Int32
- #sret?(cls) : Bool
- #sse_register?(type) : Bool
- #unify(cls, i, newv)
- #x86_64_type(type, ind_attr, context, &) : Tuple(ArgType, Int32, Int32)

  returns the LLVM type (with attributes) and the number of integer and SSE registers needed to pass this value directly (ie.

### Instance methods inherited from class `LLVM::ABI`

abi_info(atys : Array(Type), rty : Type, ret_def : Bool, context : Context) abi_info, align(type : Type, pointer_size) : Int32
align(type : Type) align, align_offset(offset, type) : Int32 align_offset, osx? : Bool osx?, size(type : Type, pointer_size) : Int32
size(type : Type) size, target_data : TargetData target_data, windows? : Bool windows?

### Constructor methods inherited from class `LLVM::ABI`

new(target_machine : TargetMachine) new

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Instance Method Detail

def abi_info(atys : Array(Type), rty : Type, ret_def : Bool, context : Context) : LLVM::ABI::FunctionType #
def align(type : Type) : Int32 #
def all_mem(reg_classes) #
def classify(ty, cls, ix, off) #
def classify(type) #
def classify_struct(tys, cls, i, off, packed) : Nil #
def fixup(ty, cls) : Nil #
def has_misaligned_fields?(type : Type, offset : Int = 0) : Bool #
def int_register?(type) : Bool #
def llreg(context, reg_classes) : LLVM::Type #
def llvec_len(reg_classes) : Int32 #
def pass_by_val?(cls) : Bool #
def register?(type) : Bool #
def size(type : Type) : Int32 #
def sret?(cls) : Bool #
def sse_register?(type) : Bool #
def unify(cls, i, newv) #
def x86_64_type(type, ind_attr, context, &) : Tuple(ArgType, Int32, Int32) #

returns the LLVM type (with attributes) and the number of integer and SSE registers needed to pass this value directly (ie. not using the stack)